import java.awt.Color;
import java.awt.Component;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.io.File;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

public class MPJData extends Component {
	//Z[uf[^̊e̊i[s\萔
	//		version 1.1 炠鍀
	static final int SAVE_FRAME_WIDTH=0;
	static final int SAVE_FRAME_HEIGHT=1;
	static final int SAVE_TIME_MINUTE=2;
	static final int SAVE_TIME_SECOND=3;
	static final int SAVE_PATH_DIR=4;		//version 1.2 ȍ~ł͕sgp
	static final int SAVE_PATH_FILE=5;	//version 1.2 ȍ~ł͕sgp
	static final int SAVE_BACK_COLOR=6;
	static final int SAVE_GENERAL_STATE=7;
	static final int SAVE_PIECE_NUM=8;
	static final int SAVE_ARRAY_ZORDER=9;
	static final int SAVE_ARRAY_GROUP=10;
	static final int SAVE_ARRAY_TOUCH=11;
	static final int SAVE_LINE_VERSION_11_ADJ=12;	//Z[ut@Cs`FbN̂߁isKvj
	//		version 1.2 ŒǉꂽځisKvj
	static final int SAVE_PATH_ALL_ADJ=12;
	static final int SAVE_FRAME_TOP_ADJ=13;
	static final int SAVE_FRAME_LEFT_ADJ=14;
	static final int SAVE_LINE_VERSION_12_ADJ=15;	//Z[ut@Cs`FbN̂߁isKvj
	//
	//PlayerɂZ[uf[^̏i[s
	static final int PLAYER_SAVE_FRAME_WIDTH=0;
	static final int PLAYER_SAVE_FRAME_HEIGHT=1;
	static final int PLAYER_SAVE_TIME_MINUTE=2;
	static final int PLAYER_SAVE_TIME_SECOND=3;
	static final int PLAYER_SAVE_FRAME_TOP=4;
	static final int PLAYER_SAVE_FRAME_LEFT=5;
	static final int PLAYER_SAVE_GENERAL_STATE=6;
	static final int PLAYER_SAVE_PIECE_NUM=7;
	static final int PLAYER_SAVE_ARRAY_ZORDER=8;
	static final int PLAYER_SAVE_ARRAY_GROUP=9;
	static final int PLAYER_SAVE_ARRAY_TOUCH=10;
	//
	//摜̎ނ\萔
	static final int I_PATTERN=0;
	static final int I_BASE=1;
	static final int I_BACK=2;
	static final int I_ALL=3;
	//e摜̃ftHgliƓɏo͂ȂǑQƂ̂Œ萔Ăj
	static final String[] N_DIR={"pattern"+System.getProperty("file.separator"),
									"base"+System.getProperty("file.separator"),
									"back"+System.getProperty("file.separator")};
	static final String[] N_FILE={"pattern.gif","base.jpg",null};
	//Z[uf[^ő΃pX̐擪ɕtĖڈɂ
	//i݊ۂ߁AZ[uf[^ł͏o邾΃pXŕۑj
	static final String RELATIVE="\\/:*?\"<>|";
	//
	//Ăяot[̃^CgύX̂߂ɕێ
	MPJApp parent;
	static final String TITLE_STRING=" - MultiPatternJigsaw";	//^Cg̍Ōɕt
	//̃vÔfBNgi΃pXƐ΃pX̕ϊ̂߁j
	String thisDir;
	//tB[h쐬ɕKvȃf[^
	File[] files;
	Image[] images;
	Color backColor;
	//Z[ut@Cf[^
	File saveFile;
	//--------------------------------------------------------
	//RXgN^
	//--------------------------------------------------------
	public MPJData(MPJApp app,boolean eF){
		parent=app;
		//
		thisDir=System.getProperty("user.dir")+System.getProperty("file.separator");
		//
		files=new File[I_ALL];
		for(int i=0;i<I_ALL;i++){
			files[i]=new File(thisDir+N_DIR[i]+".");
		}
		//
		if(eF){	//Editor
			images=getImagesOnFormat();	//ftHg摜
			backColor=MPJField.DEFAULT_BACK_COLOR;
		}else{	//PlayerȂjaȑt@CƂɎ擾
			images=getImagesOnPlayer(app.outPlayerDialog);
			backColor=app.outPlayerDialog.infoBackColor;
		}
		//iPlayerƃ^Cg̏Ⴄj
		formatSaveFileData(eF);
	}
	//--------------------------------------------------------
	//摜擾
	//--------------------------------------------------------
	//ÑftHg摜
	public Image[] getImagesOnFormat(){
		Image[] ret=new Image[I_ALL];
		ImageIcon imageIcon;
		//
		imageIcon=new ImageIcon(getClass().getResource(N_FILE[I_PATTERN]));
		ret[I_PATTERN]=imageIcon.getImage();
		imageIcon=new ImageIcon(getClass().getResource(N_FILE[I_BASE]));
		ret[I_BASE]=imageIcon.getImage();
		ret[I_BACK]=null;
		//
		return ret;
	}
	//PlayeȑꍇAjaȑt@CƂjar擾
	public Image[] getImagesOnPlayer(MPJOutPlayerDialog playDlg){
		Image[] ret=new Image[I_ALL];
		ImageIcon imageIcon;
		//
		imageIcon=new ImageIcon(getClass().getResource(playDlg.infoFilePattern));
		ret[I_PATTERN]=imageIcon.getImage();
		imageIcon=new ImageIcon(getClass().getResource(playDlg.infoFileBase));
		ret[I_BASE]=imageIcon.getImage();
		if(playDlg.infoFileBack.equals(MPJOutPlayerDialog.NO_STR)){
			ret[I_BACK]=null;
		}else{
			imageIcon=new ImageIcon(getClass().getResource(playDlg.infoFileBack));
			ret[I_BACK]=imageIcon.getImage();
		}
		//
		return ret;
	}
	//[h̎MPJAppĂяo
	public Image[] getImagesOnLoad(File[] filesNew){
		//ftHĝ܂ܕۑĂȂAftHg摜
		if(filesNew[I_PATTERN].isDirectory() || filesNew[I_BASE].isDirectory()){
			return getImagesOnFormat();
		}
		//
		MediaTracker mt=new MediaTracker(this);
		//e摜擾
		Image[] ret=new Image[I_ALL];
		ret[I_PATTERN]=Toolkit.getDefaultToolkit().getImage(filesNew[I_PATTERN].getPath());
		mt.addImage(ret[I_PATTERN],0);
		ret[I_BASE]=Toolkit.getDefaultToolkit().getImage(filesNew[I_BASE].getPath());
		mt.addImage(ret[I_BASE],0);
		if(!filesNew[I_BACK].isDirectory()){
			ret[I_BACK]=Toolkit.getDefaultToolkit().getImage(filesNew[I_BACK].getPath());
			mt.addImage(ret[I_BACK],0);
		}else{
			ret[I_BACK]=null;
		}
		//
		try{
			mt.waitForID(0);
		}catch(InterruptedException e){
			return null;
		}
		//
		return ret;
	}
	//--------------------------------------------------------
	//f[^i[
	//--------------------------------------------------------
	//tB[h쐬ɕKvȃf[^i[h̎ƐVpY쐬̎ɌĂ΂j
	public void setPuzzleData(File[] filesNew,Image[] imagesNew,Color backColorNew){
		//
		files=filesNew;
		images=imagesNew;
		backColor=backColorNew;
	}
	//Z[ut@C̃f[^
	public void setSaveFileData(File file){
		saveFile=file;
		//t[̃^Cgς
		parent.setTitle(saveFile.getName()+TITLE_STRING);
	}
	public void formatSaveFileData(boolean eF){
		saveFile=new File(thisDir+"save"+System.getProperty("file.separator")+".");
		//t[̃^Cgς
		if(eF){	//
			parent.setTitle(""+TITLE_STRING);
		}else{	//PlayerȂw肳ꂽ^Cg
			parent.setTitle(parent.outPlayerDialog.infoTitle+TITLE_STRING);
		}
	}
	//--------------------------------------------------------
	//Z[uiMPJAppĂяoj
	//--------------------------------------------------------
	public String getSaveString11(){	// version 1.1 ܂ł̃Z[upf[^Ԃ
		StringBuffer ret=new StringBuffer();
		/* version 1.1 ܂ł͂̌`ŏo͂Ă
		//fBNg
		for(int i=0;i<I_ALL;i++){
			String parentStr=files[i].getParent();
			if(parentStr.indexOf(thisDir)==0){		//΃pXA\ȂvȎ΃pXɕϊ
				ret.append(RELATIVE+parentStr.substring(thisDir.length(),parentStr.length())+System.getProperty("file.separator")+",");
			}else{
				ret.append(parentStr+System.getProperty("file.separator")+",");
			}
		}
		ret.replace(ret.length()-1, ret.length(), "\n");
		//t@C
		for(int i=0;i<I_ALL;i++){
			if(files[i].isDirectory()){
				ret.append("null,");
			}else{
				ret.append(files[i].getName()+",");
			}
		}
		ret.replace(ret.length()-1, ret.length(), "\n");
		*/
		ret.append("nouse\nnouse\n");	// version 1.2 ł͕sgp
		//wiF
		ret.append(getStringFromColor(backColor)+"\n");
		//
		return ret.toString();
	}
	public String getSavaString12(){	// version 1.2 ł̒ǉ
		StringBuffer ret=new StringBuffer();
		//
		for(int i=0;i<I_ALL;i++){
			String pathStr=files[i].getPath();
			if(pathStr.indexOf(thisDir)==0){		//΃pXA\ȂvȎ΃pXɕϊ
				ret.append(RELATIVE+pathStr.substring(thisDir.length(),pathStr.length())+",");
			}else{
				ret.append(pathStr+",");
			}
		}
		ret.replace(ret.length()-1, ret.length(), "\n");
		//
		return ret.toString();
	}
	//--------------------------------------------------------
	//[h̎ɁA摜t@C̃pXwFileNXɕϊ
	//--------------------------------------------------------
	// version 1.1 p
	public static File[] changePathFormat(String[] preDir,String[] preFile){
		//ȂG[
		if(preDir.length!=I_ALL || preFile.length!=I_ALL){
			return null;
		}
		//
		File[] ret=new File[I_ALL];
		//
		for(int f=0;f<I_ALL;f++){
			String changedDir;
			//vȎ΃pXȂ΃pXɕϊ
			if(preDir[f].indexOf(RELATIVE)==0){
				changedDir=System.getProperty("user.dir")+System.getProperty("file.separator")+preDir[f].substring(RELATIVE.length(),preDir[f].length());
			}else{
				//version 1.1܂ł͖wwi摜dirRELATIVEtȂւ̑Ή
				if(f==I_BACK && preDir[f].equals("back"+System.getProperty("file.separator"))){
					ret[f]=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+preDir[f]+".");
					continue;	//ȉ͎sȂ
				}
				//
				changedDir=preDir[f];
			}
			//
			if(preFile[f].equals("null")){
				ret[f]=new File(changedDir+".");
			}else{
				ret[f]=new File(changedDir+preFile[f]);
			}
		}
		//
		return ret;
	}
	// version 1.2 p
	public static File[] changePathFormat(String[] prePath){
		//ȂG[
		if(prePath.length!=I_ALL){
			return null;
		}
		//
		File[] ret=new File[I_ALL];
		//
		for(int f=0;f<I_ALL;f++){
			String changedPath;
			//vȎ΃pXȂ΃pXɕϊ
			if(prePath[f].indexOf(RELATIVE)==0){
				changedPath=System.getProperty("user.dir")+System.getProperty("file.separator")+prePath[f].substring(RELATIVE.length(),prePath[f].length());
			}else{
				changedPath=prePath[f];
			}
			ret[f]=new File(changedPath);
		}
		//
		return ret;
	}
	//--------------------------------------------------------
	//t@CI_CAOw`ŕ\AړIt@C̃pX𓾂
	//--------------------------------------------------------
	public static File getTargetFile(JFrame frame,String title,String button,File file,String[] ext/*FileNameExtensionFilter filter*/,boolean extensionFlag){
		//KvȊeNXÓIɌĂяo
		JFileChooser chooser=new JFileChooser();
		/* FileNameExtensionFilterMacł͎gȂ
		if(filter!=null){
			chooser.addChoosableFileFilter(filter);
		}
		*/
		chooser.setDialogTitle(title);
		chooser.setSelectedFile(file);
		//
		int ret=chooser.showDialog(frame, button);
		if(ret==JFileChooser.APPROVE_OPTION){
			//
			File selectedFile=chooser.getSelectedFile();
			//t@CɎw肳ꂽgqtĂȂΕt
			if(extensionFlag){
				String[] extensions=ext;
				/* FileNameExtensionFilterMacł͎gȂ
				String[] extensions=filter.getExtensions();
				*/
				int period=selectedFile.getPath().lastIndexOf(".");
				if(period==-1){
					selectedFile=new File(selectedFile.getPath()+"."+extensions[0]);
				}else{
					int extNum=-1;
					for(int l=0;l<extensions.length;l++){
						if(selectedFile.getPath().substring(period).equals("."+extensions[l])){
							extNum=l;
							break;
						}
					}
					if(extNum==-1){
						selectedFile=new File(selectedFile.getPath()+"."+extensions[0]);
					}
				}
			}
			//
			return selectedFile;
		}else{
			return null;
		}
	}
	//--------------------------------------------------------
	//uZ[uf[^ijvƁuvÕf[^v݂ϊÓI\bh
	//--------------------------------------------------------
	public static int getIntFromString(String data){
		try{
			return Integer.parseInt(data);
		}catch(NumberFormatException e){
			return -1;
		}
	}
	public static float getFloatFromString(String data){
		try{
			return Float.parseFloat(data);
		}catch(NumberFormatException e){
			return -1;
		}
	}
	public static String[] getStringArrayFromArrayString(String data){
		StringTokenizer st=new StringTokenizer(data,",");
		ArrayList<String> array=new ArrayList<String>();
		while(st.hasMoreTokens()){	//
			array.add(st.nextToken());
		}
		//
		String[] ret=new String[array.size()];
		for(int i=0;i<array.size();i++){
			ret[i]=array.get(i);
		}
		return ret;
	}
	public static int[] getIntArrayFromArrayString(String data){
		StringTokenizer st=new StringTokenizer(data,",");
		ArrayList<String> array=new ArrayList<String>();
		while(st.hasMoreTokens()){	//
			array.add(st.nextToken());
		}
		//
		int[] ret=new int[array.size()];
		for(int i=0;i<array.size();i++){
			try{
				ret[i]=Integer.parseInt(array.get(i));
			}catch(NumberFormatException e){
				return null;
			}
		}
		return ret;
	}
	public static String getArrayStringFromIntArray(int[] data){
		StringBuffer ret=new StringBuffer();
		for(int i=0;i<data.length;i++){
			ret.append(data[i]+",");
		}
		ret.append("\n");
		//
		return ret.toString();
	}
	public static int[][] getIntDoubleArrayFromDoubleArrayString(String[] data,int start,int end){
		int[][] ret=new int[end-start][];
		for(int i=start;i<end;i++){
			ret[i-start]=MPJData.getIntArrayFromArrayString(data[i]);
			if(ret[i-start]==null){
				return null;
			}
		}
		//
		return ret;
	}
	public static String getDoubleArrayStringFromDoubleIntArray(int[][] data){
		StringBuffer ret=new StringBuffer();
		for(int i=0;i<data.length;i++){
			for(int j=0;j<data[0].length;j++){
				ret.append(data[i][j]+",");
			}
			ret.append("\n");
		}
		//
		return ret.toString();
	}
	public static Color getColorFromString(String data){
		try{
			return Color.decode("0x"+data);	//16i񂩂F쐬
		}catch(NumberFormatException e){
			return MPJField.DEFAULT_BACK_COLOR;
		}
	}
	public static String getStringFromColor(Color data){
		return Integer.toHexString(data.getRGB() & 0x00ffffff);	//At@[l16ił̕\
	}
}
