import java.applet.AudioClip;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MenuItem;
import java.awt.Point;
import java.awt.PopupMenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.PixelGrabber;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class MPJField extends JPanel implements Runnable,MouseListener, MouseMotionListener,ComponentListener,ActionListener {
	//
	//******************************************************************************************************
	//Niplaypj
	//------------------------------------------------------------------------------------------------------
	public static void main(String[] args) {
		MPJApp frame=new MPJApp(false);	//false
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//******************************
	//ftHg̔wiF
	static final Color DEFAULT_BACK_COLOR=new Color(220,220,220);
	//pY̏Ԃ\萔
	static final int S_ANALYZING=0;	//
	static final int S_PLAYING=1;		//
	static final int S_FINISHED=2;	//
	static final int S_ANSWER=3;		//
	static final int S_ERROR=4;		//
	static final int S_ALL=5;			//
	//O[vɂăs[X̏Ԃ\萔
	static final int P_INGROUP=-1;	//
	static final int P_FAR=0;			//ڂȂ
	static final int P_NEAR=1;		//ڂ
	//******************************
	//pỸs[X
	MPJPiece pieces[/*s[Xԍ*/];
	//pY@\邽߂̔z
	int zorder[/*O*/];					//̐[ɂs[X
	int group[/*s[Xԍ*/];						//̃s[X͂ǂ̃O[vɑ邩
	int touch[/*O[vԍ*/][/*s[Xԍ*/];	//̃O[vł̂̃s[Xɑ΂ԁiAڂȂAڂj
	//IĂs[X
	int selected;
	//******************************
	//tB[h̑傫
	int fieldWidth,fieldHeight;
	//\̂߂̍W
	int medx,medy;
	//ȑÕ}EXWi}EXɂāj
	int oldx,oldy;
	//******************************
	//C[W
	Image patternImage,baseImage,backImage;
	//p^[A摜̑傫
	int imageWidth,imageHeight;
	//wi摜̑傫
	int backWidth,backHeight;
	//******************************
	//s[XȈȗ`p̉摜
	Graphics tmpG;
	Image tmpI;
	//ȗ摜쐬tOi쐬̕Kvtrueɂj
	boolean tmpF;
	//******************************
	//tO
	private int generalState;
	//͒̏\
	String analyzingState;
	//******************************
	//ʉ
	AudioClip audioBang=null;
	AudioClip audioTouch=null;
	AudioClip audioCongra=null;
	//ŏ番ăQ[X^[g邩ǂ
	boolean firstBreakFlag=false;
	//******************************
	//[hƂɁA͑OɃf[^dłA͏IɓK
	int loadGeneralState;
	int[] loadZorder=null;
	int[] loadGroup=null;
	int[][] loadTouch=null;
	int[][] loadPiecePos=null;
	//******************************
	//摜͗p̃Xbh
	Thread analyzeThread = null;
	boolean waitFlag;	//TCY擾҂ǂiȂ҂ȂƓȂj
	//******************************
	//Is[Xŉ@\Popup
	PopupMenu popupMenu=new PopupMenu();
	MenuItem deepOnce=new MenuItem("Is[Xŉֈړ");
	MenuItem deepKeep=new MenuItem("Is[Xŉ֌Œ");
	MenuItem deepCancel=new MenuItem("ŉւ̌Œ");
	int deepPiece;		//ŉŒ̑Is[X
	int oldSelected;	//pɈꎞۑiOɑIs[X邩Ȃj
	//-------------------------------------------------------------
	//i\W𓾂邽߁AReigɔzuŃpY쐬j
	//-------------------------------------------------------------
	//RXgN^i܂pY͍Ȃj
	public MPJField(){
		//Cxg̐ݒ
		addMouseListener(this);
		addMouseMotionListener(this);
		addComponentListener(this);
		//Is[Xŉ@\Popup
		popupMenu.add(deepOnce);
		popupMenu.addSeparator();
		popupMenu.add(deepKeep);
		popupMenu.add(deepCancel);
		add(popupMenu);
		deepOnce.addActionListener(this);
		deepKeep.addActionListener(this);
		deepCancel.addActionListener(this);
		deepPiece=-1;
		oldSelected=-1;
	}
	//󂯎f[^ŃpY쐬irŃpYVꍇj
	public void newJigsaw(Image patternI,Image baseI,Color backC,Image backI,boolean wait){
		//xAɂi}邽߁j
		pieces=null;
		zorder=null;
		group=null;
		touch=null;
		//󂯎f[^𓖂Ă͂
		patternImage=patternI;
		baseImage=baseI;
		backImage=backI;
		if(backC!=null){
			setBackground(backC);		//wiF
		}else{
			setBackground(DEFAULT_BACK_COLOR);		//ftHg̐F
		}
		waitFlag=wait;
		//ŉŒs[X͉
		deepPiece=-1;
		//
		//͏Ԃɐݒ
		analyzingState="";
		setGeneralState(S_ANALYZING);
		//̓X^[g
		analyzeThread=new Thread(this);
		analyzeThread.start();
	}
	//-------------------------------------------------------------
	//ʉƊ摜\̐ݒirŕύX邱Ƃj
	//-------------------------------------------------------------
	public void setSoundEffect(AudioClip bang,AudioClip touch,AudioClip congra){
		audioBang=bang;
		audioTouch=touch;
		audioCongra=congra;
	}
	public void setFirstBreakFlag(boolean flag){
		firstBreakFlag=flag;
	}
	//------------------------------------------------------
	//s[X̔zu
	//------------------------------------------------------
	//s[Xi𓚕\j
	public void formatAllPos(){
		if(mustReturnState()){
			return;
		}
		//̌ʉ
		if(audioTouch!=null){	audioTouch.play();	}
		//SẴs[Xɂ
		for(int i=0;i<pieces.length;i++){
			//
			pieces[i].formatPos(medx,medy);
			//OO[vɑ
			touch[0][i]=P_INGROUP;
			group[i]=0;
			//
			zorder[i]=i;
		}
		//ŉŒs[X͉
		deepPiece=-1;
		//
		setGeneralState(S_ANSWER);
		repaint();
	}
	//s[X𕪉ă_ɔzuipYJnj
	public void randomAllPos(){
		if(mustReturnState()){
			return;
		}
		//̌ʉ
		if(audioBang!=null){	audioBang.play();	}
		//SẴs[Xɂ
		for(int i=0;i<pieces.length;i++){
			//_Ɉʒu߂
			pieces[i].randomPos(fieldWidth,fieldHeight);
			//eO[vɂ̔ԍ̃s[Xlɂ
			group[i]=i;								//s[XԍO[vԍ
			for(int j=0;j<pieces.length;j++){
				touch[i][j]=P_FAR;					//UASď
			}
			touch[i][i]=P_INGROUP;					//s[X
			for(int j=0;j<pieces[i].touch.length;j++){
				touch[i][pieces[i].touch[j]]=P_NEAR;	//s[Xڂs[X
			}
			//
			zorder[i]=i;
		}
		//ŉŒs[X͉
		deepPiece=-1;
		//
		setGeneralState(S_PLAYING);
		repaint();
	}
	//s[X݂̃tB[hɍĔzuitB[h̑傫ς邱Ƃ̂Łj
	public void fitAllPos(){
		if(mustReturnState()){
			return;
		}
		//O[vƂɍl
		int beforeGroup;
		int startZ,endZ;
		//
		beforeGroup=group[zorder[0]];
		startZ=0;
		//Õs[X珇ԂɃ`FbN
		for(int i=1;i<zorder.length;i++){
			//̃O[vIĂ
			if(group[zorder[i]]!=beforeGroup){
				endZ=i-1;
				//̃O[ṽtB[hO͂ݏoC
				fitSameGroupPos(startZ,endZ);
				//̃O[v
				beforeGroup=group[zorder[i]];
				startZ=i;
			}
		}
		//Ō̃O[v
		endZ=zorder.length-1;
		fitSameGroupPos(startZ,endZ);
		//
		repaint();
	}
	//w肳ꂽ[̃s[XiO[v̂͂j̃tB[hO͂ݏoC
	private void fitSameGroupPos(int startZ,int endZ){
		//̃O[v̍ŊO擾
		Point leftUp=null;
		Point rightDown=null;
		for(int i=startZ;i<=endZ;i++){
			leftUp=pieces[zorder[i]].addImageAreaLeftUp(leftUp);
			rightDown=pieces[zorder[i]].addImageAreaRightDown(rightDown);
		}
		//ړ̑傫Zo
		int dx=0,dy=0;
		if(leftUp.x<0){
			dx=-leftUp.x;
		}else if(rightDown.x>fieldWidth){
			dx=fieldWidth-rightDown.x;
		}
		if(leftUp.y<0){
			dy=-leftUp.y;
		}else if(rightDown.y>fieldHeight){
			dy=fieldHeight-rightDown.y;
		}
		//ړs
		if(dx!=0 || dy!=0){
			for(int i=startZ;i<=endZ;i++){
				pieces[zorder[i]].moveImage(dx,dy);
			}
		}
	}
	//------------------------------------------------------
	//Z[uƃ[h
	//------------------------------------------------------
	public void stockLoadData(int gs,int[] z,int[] g,int[][] t,int[][] p){	//[hd
		loadGeneralState=gs;
		loadZorder=z;
		loadGroup=g;
		loadTouch=t;
		loadPiecePos=p;
	}
	private void deleteLoadData(){	//dł[hjiKG[̎Ȃǁj
		loadZorder=null;
		loadGroup=null;
		loadTouch=null;
		loadPiecePos=null;
	}
	public String getSaveString(){	//Z[upf[^ԂiMPJAppĂяoj
		StringBuffer ret=new StringBuffer();
		ret.append(getGeneralState()+"\n");
		ret.append(pieces.length+"\n");
		ret.append(MPJData.getArrayStringFromIntArray(zorder));
		ret.append(MPJData.getArrayStringFromIntArray(group));
		ret.append(MPJData.getDoubleArrayStringFromDoubleIntArray(touch));
		for(int i=0;i<pieces.length;i++){
			ret.append(pieces[i].getSaveString());	//MPJPiece
		}
		//
		return ret.toString();
	}
	//------------------------------------------------------------------------------------------
	//s̒
	//------------------------------------------------------------------------------------------
	//s[XIꂽƂAZ-orderւ
	private void changeZorder(int n){
		//ёւp̈ꎞϐ
		int tmp[]=new int[zorder.length];	//Z-orderp̔z
		int m=0;	//YƂĎgp
		//
		int s=-1;	//IO[v̊Jnʒu
		int e=-1;	//IO[v̏Iʒu
		//܂IO[vꎞϐɊi[Ăiłj
		for(int i=0;i<zorder.length;i++){
			//IO[vȂ
			if(group[zorder[i]]!=group[zorder[n]]){
				tmp[m]=zorder[i];	//i[
				m++;				//Y𑝂₷
			//IO[voĂ
			}else{
				if(s==-1){	//oȂJnEIʒui[
					s=i;
					e=i;
				}else{		//ȍ~͏IʒuXV
					e=i;
				}
			}
		}
		//ŌɑIO[vꎞϐɊi[ił\Ɂj
		for(int i=s;i<=e;i++){
			tmp[m]=zorder[i];	//i[
			m++;				//Y𑝂₷
		}
		//ꎞϐZ-orderɓւ
		zorder=tmp;
	}
	//w肳ꂽs[X̃O[vŉɈړiMousePopupMenũCxgĂ΂j
	private void moveDeepest(int pieceNum){
		//ёւp̈ꎞϐ
		int tmp[]=new int[zorder.length];	//Z-orderp̔z
		//
		int s=-1;	//IO[v̍ł
		int e=-1;	//IO[v̍łO
		//܂IO[v͈̔͂𒲂ׂiʏAłOɂ͂j
		for(int z=zorder.length-1;z>=0;z--){
			//IO[vȂ
			if(group[zorder[z]]==group[pieceNum]){
				if(e==-1){	//oȂJnEIʒui[
					e=z;
					s=z;
				}else{		//ȍ~͏IʒuXV
					s=z;
				}
			//IO[voĂ
			}else{
				if(s!=-1){	//IO[vɏoĂΏI
					break;
				}
			}
		}
		//IO[ṽs[X
		int m=e-(s-1);
		//ŌɑIO[vŉɕבւAꎞϐɊi[
		for(int z=zorder.length-1;z>=0;z--){
			if(z>e){
				tmp[z]=zorder[z];	//ʏAłOɔIO[v͗Ȃ
			}else if(z>=s && z<=e){
				tmp[z-s]=zorder[z];	//IO[vŉɈړ
			}else if(z<s){
				tmp[z+m]=zorder[z];	//IO[v܂Ƃ߂ĎOɈړ
			}
		}
		//ꎞϐZ-orderɓւ
		zorder=tmp;
	}
	//-------------------------------------------------------------
	//swingɂ`惁\bh
	//-------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//̕`
		if(getGeneralState()==S_ANALYZING){
			g.setColor(Color.black);
			g.fillRect(0,0,getSize().width,getSize().height);	//wihԂ
			g.setColor(Color.WHITE);
			g.drawString(analyzingState,50,50);
		//G[̕`
		}else if(getGeneralState()==S_ERROR){
			g.setColor(Color.ORANGE);
			g.fillRect(0,0,getSize().width,getSize().height);	//wihԂ
			g.setColor(Color.BLACK);
			g.drawString(analyzingState,50,50);
		//̑̕`ivCAς݁A𓚕\j
		}else{
			//s[XIĂΏȗ`
			if(selected!=-1){
				//ȗ摜쐬Ȃ쐬
				if(tmpF){
					//wi
					tmpG.fillRect(0,0,fieldWidth,fieldHeight);	//wihԂ
					fillBackImage(tmpG);	//wi摜~l
					//ẃAIĂȂs[X
					for(int i=0;i<zorder.length;i++){
						if(group[zorder[i]]!=group[selected]){
							MPJPiece p=pieces[zorder[i]];
							tmpG.drawImage(p.img,p.getPX(),p.getPY(),this);
						}else{
							break;
						}
					}
					//tO߂
					tmpF=false;
				}
				//ȗ摜
				g.drawImage(tmpI,0,0,this);
				//I𒆂̃s[X
				for(int i=zorder.length-1;i>=0;i--){
					if(group[zorder[i]]==group[selected]){
						MPJPiece p=pieces[zorder[i]];
						g.drawImage(p.img,p.getPX(),p.getPY(),this);
					}else{
						break;
					}
				}
			//s[XIĂȂΒʏ`
			}else{
				//wi
				fillBackImage(g);	//wi摜~l
				//Ss[X
				for(int i=0;i<zorder.length;i++){
					MPJPiece p=pieces[zorder[i]];
					g.drawImage(p.img,p.getPX(),p.getPY(),this);
				}
			}
		}
	}
	private void fillBackImage(Graphics g){	//wi摜~l
		if (backImage != null){
			//wi摜^Cɕ~l߂
			for(int h=0;h<=fieldHeight/backHeight;h++){
				for(int w=0;w<=fieldWidth/backWidth;w++){
					g.drawImage(backImage,w*backWidth,h*backHeight,this);
				}
			}
		}
	}
	//--------------------------------------------------------------
	//}EXAbṽs[X
	//--------------------------------------------------------------
	//nꂽZ-order̃s[XO[v͑IO[vƐڂ邩ǂ
	private boolean checkNear(int n){
		//Yɂil͓nꂽZ-orderj
		int i=n;
		//̃O[vɑs[XԂɒׂĂĩO[vZ-order͘AĂj
		do{
			//ڂs[X΂ŏI
			if(touch[group[selected]][zorder[i]]==P_NEAR){	return true;	}
			i--;	//ЂƂ̃s[X
		//Ō̃s[XɍsAႤO[vɂȂ܂ő
		}while(i>=0 && group[zorder[i]]==group[zorder[n]]);
		//Ō܂ŒׂĂȂꍇ
		return false;
	}
	//-------------------------------------------------------------
	//}EXCxg
	//-------------------------------------------------------------
	public void mouseDragged(MouseEvent e) {     //hbO
		if(mustReturnState()){
			return;
		}
		//s[XIĂ
		if(selected!=-1){
			//}EXJ[\݈̌ʒu
			int ax=e.getX();
			int ay=e.getY();
			//ړ
			int dx=ax-oldx;
			int dy=ay-oldy;
			//O[ṽs[XSēlɈړ
			for(int i=0;i<pieces.length;i++){
				if(group[i]==group[selected]){
					pieces[i].moveImage(dx,dy);
				}
			}
			//݈ʒuʒuɐݒ
			oldx=ax;
			oldy=ay;
			//ĕ`
			repaint();
		}
	}
	public void mousePressed(MouseEvent e) {	//}EX{^
		if(mustReturnState()){
			return;
		}
		//}EX_EW
		int ax=e.getX();
		int ay=e.getY();
		//łÕs[X珇Ԃɒׂ
		for(int i=zorder.length-1;i>=0;i--){
			//̃s[X̔񓧖ɂĂ
			if( pieces[zorder[i]].checkOn(ax,ay) ){
				//̃s[XI
				selected=zorder[i];
				//O[ṽs[XSđOʂ
				changeZorder(i);
				//}EX_EWʒuɐݒ
				oldx=ax;
				oldy=ay;
				//ȗ摜쐬tO
				tmpF=true;
				//ĕ`
				repaint();
				//艜̃C[ׂ͒ɏI
				break;
			}
		}
	}
	public void mouseReleased(MouseEvent e) {    //}EX{^
		if(mustReturnState()){
			return;
		}
		//s[XIȂ猋`FbNs
		if(selected!=-1){
			checkPieceJoin();
		}
		//Is[Xŉ@\Popup\
		if(e.isPopupTrigger()){
			showPopup(e.getX(),e.getY());
		}
		//Is[XŉŒ`FbNs
		if(checkDeepest(selected)){
			moveDeepest(selected);
		}
		//s[XI
		selected=-1;
		//ĕ`
		repaint();
	}
	public void mouseExited(MouseEvent arg0) {	//}EXo
		if(mustReturnState()){
			return;
		}
		//Is[XŉŒ`FbNs
		if(checkDeepest(selected)){
			moveDeepest(selected);
		}
		//
		selected=-1;	//s[XI
		repaint();	//ĕ`
	}
	public void mouseEntered(MouseEvent arg0) {}	//}EX
	public void mouseMoved(MouseEvent arg0) {}      //}EX𓮂
	public void mouseClicked(MouseEvent arg0) {}	//NbN
	//s[X̌`FbNsimouseReleasedĂ΂j
	private void checkPieceJoin(){
		//
		int g=0;	//ŏIIɁAIO[vɑs[X̌
		boolean change=false;	//s[Xǂ̃tO
		//
		//[vɂ鏈p̕ϐ
		int f=P_INGROUP;			//tOiĺuO[vvj
		int before=group[selected];	//Õs[XO[vi[Ăil͑I𒆂̃O[vj***ArrayIndexOutOFBoundsException
		//Õs[X珇ԂɁAs[X蓾邩`FbN
		for(int i=zorder.length-1;i>=0;i--){
			//Õs[XƓO[vȂ
			if(group[zorder[i]]==before){
				//tOɂď
				switch(f){
				case P_FAR:	//uڂȂvȂAȂ
					break;
				case P_INGROUP:	//uO[vvȂ
					g++;		//Ziɂ͑IO[vłȂj
					break;
				case P_NEAR:	//uڂvȂAs[X
					pieces[zorder[i]].setGroup(pieces[selected]);	//̃s[ẌʒuIO[vɍ킹
					group[zorder[i]]=group[selected];				//̃s[XIO[vɑ
					g++;		//Z
					break;
				}
			//Õs[XƈႤO[vȂ
			}else{
				//s[Xiʒu߂Đڂs[Xłj
				if(pieces[zorder[i]].checkGroupable(pieces[selected]) && checkNear(i)){
					//̃O[vz
					for(int j=0;j<touch[group[zorder[i]]].length;j++){
						//O[v̊es[Xɑ΂Ԃ𒲂ׂ
						switch(touch[group[zorder[i]]][j]){
						case P_INGROUP:	//uvȂAIO[vłuv
							touch[group[selected]][j]=P_INGROUP;
							break;
						case P_FAR:		//uڂȂvȂAȂ
							break;
						case P_NEAR:		//uڂvŊIO[vɑĂȂ΁A
							if(touch[group[selected]][j]!=P_INGROUP){
								touch[group[selected]][j]=P_NEAR;	//IO[vłuڂv
							}
							break;
						}
					}
					//
					before=group[zorder[i]];	//̃s[X̃O[v𒼑OO[vɐݒ
					f=P_NEAR;						//tOuڂvɐݒ
					//
					pieces[zorder[i]].setGroup(pieces[selected]);	//̃s[ẌʒuIO[vɍ킹
					group[zorder[i]]=group[selected];				//̃s[XIO[vɑ
					g++;	//Z
					//
					change=true;	//s[XtO𗧂Ă
				//s[XȂ
				}else{
					before=group[zorder[i]];	//̃s[X̃O[v𒼑OO[vɐݒ
					f=P_FAR;						//tOuڂȂvɐݒ
				}
			}
		}
		//s[XĂ
		if(change){
			//̌ʉ
			if(audioTouch!=null){	audioTouch.play();	}
			//̃`FbN
			if(g==pieces.length){	//SẴs[XIO[vɊ܂܂ĂΊ
				//̌ʉ
				if(audioCongra!=null){	audioCongra.play();	}
				setGeneralState(S_FINISHED);
			}else{					//Ȃz-orderёւ
				//ꎞϐ
				int tmp[]=new int[zorder.length];
				//
				int gb=0;	//IO[vp̓Y
				int ga=0;	//IO[vp̓Y
				//Õs[X
				for(int i=zorder.length-1;i>=0;i--){
					//IO[vȂ
					if(group[zorder[i]]==group[selected]){
						tmp[zorder.length-1-gb]=zorder[i];	//\Ɋi[Ă
						gb++;	//Z
					//IO[vȂ
					}else{
						tmp[zorder.length-1-g-ga]=zorder[i];	//Ɋi[Ă
						ga++;	//Z
					}
				}
				//ꎞϐz-orderɓւ
				zorder=tmp;
			}
		}
	}
	//Is[XŉŒs邩`FbNimouseReleasedmouseExitedĂ΂j
	private boolean checkDeepest(int selectedPiece){
		if(deepPiece==-1 || selectedPiece==-1){	//w薳A܂́As[XI
			return false;
		}
		if(group[deepPiece]==group[selectedPiece]){
			return true;	//Is[XO[vȂŉړ邱ƂɂȂ
		}else{
			return false;
		}
	}
	//------------------------------------------------------
	//ʏ̏Ă͂ȂԂ`FbNi͒ƃG[ԁj
	//------------------------------------------------------
	public boolean mustReturnState(){
		int tmpState=getGeneralState();
		if(tmpState==S_ANALYZING || tmpState==S_ERROR){
			return true;
		}else{
			return false;
		}
	}
	//-------------------------------------------------------------
	//R|[lgCxgitB[h̑傫ύX擾j
	//-------------------------------------------------------------
	public void componentResized(ComponentEvent e){
		fitFieldSize(true);	//TCY܂ő҂
		repaint();	//ĕ`悵ȂĂ͂Ȃ
	}
	public void componentMoved(ComponentEvent e){
	}
	public void componentShown(ComponentEvent e){
	}
	public void componentHidden(ComponentEvent e){
	}
	//--------------------------------------------------------------
	//tB[h̑傫ςƂ̍Đݒ
	//--------------------------------------------------------------
	public void fitFieldSize(boolean wait){
		//if(getSize().width!=fieldWidth || getSize().height!=fieldHeight){
		//iʑj̋NȊOł̓TCY܂ő҂iȂ҂ȂƓȂj
		if(wait){
			while(getSize().width<=0);
		}
		//tB[h̑傫Ɖ𓚕\WĐݒ
		fieldWidth=getSize().width;
		fieldHeight=getSize().height;
		medx=(int)((fieldWidth-imageWidth)/2);
		medy=(int)((fieldHeight-imageHeight)/2);
		//ȗ摜̍쐬
		try{
			tmpI=createImage(fieldWidth,fieldHeight);
		}catch(Exception e){
		}
		if(tmpI!=null){
			tmpG=tmpI.getGraphics();
			tmpG.setColor(getBackground());	//\摜ƓwiF
		}
		//}
	}
	//-------------------------------------------------------------
	//pY̏ԁiK̃\bhgj
	//-------------------------------------------------------------
	public synchronized int getGeneralState(){
		return generalState;
	}
	private synchronized void setGeneralState(int state){
		generalState=state;
	}
	//-------------------------------------------------------------
	//ʃXbhŉ摜𕪐͂AKvȃIuWFNg쐬
	//-------------------------------------------------------------
	public void run(){
		//
		try{
			//***********************
			analyzingState="摜𕪐͒";
			repaint();	//ĕ`
			//***********************
			int ppix[],bpix[];		//C[W̃sNZz
			//C[W̃TCY擾
			imageWidth=patternImage.getWidth(this);
			imageHeight=patternImage.getHeight(this);
			//摜擾łĂȂi݂Ȃ摜w肵ȂǁjȂG[
			if(imageWidth==-1 || baseImage.getWidth(this)==-1){
				//+++++++++++++++++++++++
				analyzingState="摜擾ł܂ł";
				setGeneralState(S_ERROR);
				deleteLoadData();	//G[ȂZ[uf[^Ă
				repaint();	//ĕ`
				//+++++++++++++++++++++++
				return;	//I
			}
			//p^[t@Cƌ摜̑傫Ⴆ΃G[
			if(baseImage.getWidth(this)!=imageWidth || baseImage.getHeight(this)!=imageHeight){
				//+++++++++++++++++++++++
				analyzingState="摜̑傫p^[ƈv܂";
				setGeneralState(S_ERROR);
				deleteLoadData();	//G[ȂZ[uf[^Ă
				repaint();	//ĕ`
				//+++++++++++++++++++++++
				return;	//I
			}
			//C[W̃sNZz쐬
			ppix=new int[imageWidth*imageHeight];	//p^[t@C
			bpix=new int[imageWidth*imageHeight];	//摜
			//C[W̃sNZo
			try{
				PixelGrabber ppg=new PixelGrabber(patternImage,0,0,imageWidth,imageHeight,ppix,0,imageWidth);
				ppg.grabPixels();
				PixelGrabber bpg=new PixelGrabber(baseImage,0,0,imageWidth,imageHeight,bpix,0,imageWidth);
				bpg.grabPixels();
			}catch(InterruptedException ie){
				//+++++++++++++++++++++++
				analyzingState="摜͂̕Ɏs܂";
				setGeneralState(S_ERROR);
				deleteLoadData();	//G[ȂZ[uf[^Ă
				repaint();	//ĕ`
				//+++++++++++++++++++++++
				return;	//I
			}
			//쐬s[Xi[xN^[in߂͌Ȃj
			ArrayList<MPJPiece> pieceArray=new ArrayList<MPJPiece>();
			//p^[t@C̑SsNZԂɒׂ
			for(int i=0;i<imageWidth*imageHeight;i++){
				//̃sNZsȂi̓pYɂȂ̂Łj
				if( checkAlpha( ppix[i]) ){
					//̃sNZ̐F͂܂łɏoĂiԖڂɏoĂj
					int num=getElemNum(pieceArray,ppix[i]);
					//܂łɂ͏oĂȂiVɏoĂFj
					if( num==-1 ){
						//p^[t@C̃sNZnăs[X쐬AxN^[ɓ
						//i}邽߁Ao̍snč쐬zʂߖj
						pieceArray.add(new MPJPiece(ppix[i],imageWidth,imageHeight,(int)(i/imageWidth)));
						num=pieceArray.size()-1;	//
					}
					//񏈗s[Xo
					MPJPiece tmp=pieceArray.get(num);
					//s[Xɓʒǔ摜sNZn
					tmp.setPixel(bpix[i],i);
					//p^[t@C̏̃sNZႤFȂiאڃs[Xoj
					if( i>=imageWidth && ppix[i]!=ppix[i-imageWidth] ){
						tmp.addTouch(ppix[i-imageWidth]);	//̃sNZאڏƂēo^
					}
					//p^[t@C̍̃sNZႤFȂiאڃs[Xoj
					if( i%imageWidth!=0 && ppix[i]!=ppix[i-1] ){
						tmp.addTouch(ppix[i-1]);		//̃sNZאڏƂēo^
					}
				}
			}
			//***********************
			analyzingState="pỸs[X쐬";	//
			repaint();	//ĕ`
			//***********************
			//s[Xi[z
			pieces=new MPJPiece[pieceArray.size()];
			//s[X̖
			for(int i=0;i<pieceArray.size();i++){
				//Vectors[Xo
				MPJPiece tmp=pieceArray.get(i);
				//ڂs[Xm
				for(int j=i+1;j<pieceArray.size();j++){	//̎̃s[X璲ׂio`FbNȂ̂łłj
					tmp.checkTouch(i,pieceArray.get(j),j);
				}
				tmp.makeTouch();
				//s[XŃsNZz񂩂C[W쐬
				tmp.makeImage();
				//zɊi[
				pieces[i]=tmp;
			}
		}catch(OutOfMemoryError er){	//͒ɃI[o[
			//+++++++++++++++++++++++
			analyzingState="܂ł";
			setGeneralState(S_ERROR);
			deleteLoadData();	//G[ȂZ[uf[^Ă
			repaint();	//ĕ`
			//+++++++++++++++++++++++
			return;	//I
		}
		//
		//***********************
		analyzingState="̑";	//
		repaint();	//ĕ`
		//***********************
		//߂̓s[XI
		selected=-1;
		//tB[h̑傫ɍ킹āiŕς邱Ƃj
		fieldWidth=fieldHeight=0;
		fitFieldSize(waitFlag);
		//ȗ摜쐬tO
		tmpF=false;
		//wi摜̑傫߂Ă
		if (backImage != null){
			backWidth=backImage.getWidth(this);
			backHeight=backImage.getHeight(this);
		}else{
			backWidth=backHeight=0;
		}
		//zp
		if(loadZorder!=null){	//[hf[^
			//s[X̐ႤG[
			if(loadZorder.length!=pieces.length){
				//+++++++++++++++++++++++
				analyzingState="摜Z[ut@Cƈv܂";
				setGeneralState(S_ERROR);
				deleteLoadData();	//G[ȂZ[uf[^Ă
				repaint();	//ĕ`
				//+++++++++++++++++++++++
				return;	//I
			}
			//Ă͂
			zorder=loadZorder;
			group=loadGroup;
			touch=loadTouch;
			//
			for(int i=0;i<pieces.length;i++){
				pieces[i].moveImageTo(loadPiecePos[i][0],loadPiecePos[i][1]);
			}
			//
			setGeneralState(loadGeneralState);
			//[hIf[^폜Ă
			deleteLoadData();
			//
			repaint();
			return;	//̂܂܏Ii̕KvȂj
		}else{	//[hf[^ȂΒPɏ
			zorder=new int[pieces.length];
			group=new int[pieces.length];
			touch=new int[pieces.length][pieces.length];
		}
		//
		//s[Xzu
		if(firstBreakFlag){	//ŏ番ꍇ
			setGeneralState(S_PLAYING);
			randomAllPos();	//s[X𕪉_ɔzu
		}else{		//Ȃꍇ
			setGeneralState(S_ANSWER);
			formatAllPos();	//s[X}\
		}
		//
		repaint();	//ĕ`
	}
	//------------------------------------------------------------------------
	//Xbhł̃p^[t@C͂Ă΂
	//------------------------------------------------------------------------
	//nꂽsNZsł邩
	private boolean checkAlpha(int d){
		//At@[lixjo
		int a=(d >> 24) & 0xff;
		if(a>0){
			return true;	//s
		}else{
			return false;	//
		}
	}
	//p^[t@Ĉ̃sNZ̐F͂܂łɏoĂiԖڂɏoĂj𒲂ׂ
	private int getElemNum(ArrayList<MPJPiece> v,int p){
		//܂ō쐬s[XԂɒׂ
		for(int i=0;i<v.size();i++){
			if( ((MPJPiece)(v.get(i))).checkPattern(p) ){
				return i;	//oĂĂioĂԍԂj
			}
		}
		return -1;			//܂łɂ͏oĂȂ
	}
	//------------------------------------------------------------------------
	//PopupMenuCxgiIs[Xŉ@\j
	//------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==deepOnce){			//ŉړ݂̂ŁAŒ̎w͂Ȃ
			moveDeepest(oldSelected);
			repaint();
		}else if(e.getSource()==deepKeep){		//ŉɌŒ̎w܂ł
			deepPiece=oldSelected;
			moveDeepest(deepPiece);
			repaint();
		}else if(e.getSource()==deepCancel){	//ŉŒ̎w
			deepPiece=-1;
		}
	}
	//------------------------------------------------------------------------
	//Is[Xŉ@\PopupMenu\ieڂ̗LE\OɌ߂j
	//------------------------------------------------------------------------
	private void showPopup(int px,int py){
		//s[XIĂ΍ŉړEw肪\
		oldSelected=selected;
		if(oldSelected==-1){
			deepOnce.setEnabled(false);
			deepKeep.setEnabled(false);
		}else{
			deepOnce.setEnabled(true);
			deepKeep.setEnabled(true);
		}
		//ŉŒɎw肵ĂΉ\
		if(deepPiece==-1){
			deepCancel.setEnabled(false);
		}else{
			deepCancel.setEnabled(true);
		}
		//
		popupMenu.show(this,px,py);
	}
}
