import java.awt.Component;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Point;
import java.awt.image.MemoryImageSource;
import java.util.ArrayList;

public class MPJPiece extends Component {	//C[W쐬̂߂Ɍp
	//N͂̕Ɏg
	int pattern;		//p^[t@C̎̐F
	ArrayList<Integer> touchpix;	//ڂFo^
	ArrayList<Integer> touchnum;	//ڂs[Xԍo^
	//쐬C[W
	Image img;
	//C[W̑傫
	int imageWidth,imageHeight;			//C[W
	int imageWidthSmall,imageHeightSmall;	//쐬C[W
	//C[W̃sNZz
	int pix[];		//C[W
	int pixsmall[];	//쐬C[W
	//C[W̃sNZzǂ̍s邩i}邽߁j
	int startLine;
	//̃s[X̕\ʒuiC[Wɂj
	int px,py;
	//C[Wɂ񓧉ߕ̍ŊO
	int left,right,up,down;
	//ڂs[X̃s[Xԍ
	int touch[];
	//--------------------------------------------------------
	//RXgN^
	//--------------------------------------------------------
	public MPJPiece(int p,int w,int h,int line){
		//摜ƃp^[t@C̏󂯎
		pattern=p;
		imageWidth=w;
		imageHeight=h;
		//C[WsNZzJns
		startLine=line;
		//
		pix=new int[w*(h-startLine)];	//Jns͍Ȃ
		px=py=0;
		left=w;
		up=h;
		right=0;
		down=0;
		touchpix=new ArrayList<Integer>();
		touchnum=new ArrayList<Integer>();
	}
	//--------------------------------------------------------
	//C[W쐬in߂͂̕Ŏgj
	//--------------------------------------------------------
	//nꂽp^[t@C̐F񂪎Ɠǂ
	public boolean checkPattern(int p){
		if(pattern==p){
			return true;	//
		}else{
			return false;	//Ⴄ
		}
	}
	//̃s[XɕKvȌ摜̃sNZ󂯎i[Ă
	public void setPixel(int d,int n){
		//w肳ꂽsNZʒuɓnꂽFi[
		pix[n-(imageWidth*startLine)]=d;	//Jns𖳎
		//񓧉ߕ̍ŊOXV
		left=Math.min(left,n%imageWidth);
		right=Math.max(right,n%imageWidth);
		up=Math.min(up,n/imageWidth);
		down=Math.max(up,n/imageWidth);

	}
	//C[W쐬i͂̍Ōɍsj
	public void makeImage(){
		//쐬C[W̑傫
		imageWidthSmall=right-(left-1);
		imageHeightSmall=down-(up-1);
		//쐬C[W̃sNZz
		pixsmall=new int[imageWidthSmall*imageHeightSmall];
		//񓧉ߕ̎lp͈̔͂ŃsNZڂiC[W쐬C[Wցj
		for(int i=up;i<=down;i++){
			for(int j=left;j<=right;j++){
				pixsmall[(i-up)*imageWidthSmall+(j-left)]=pix[(i-startLine)*imageWidth+j];	//Jns𖳎
			}
		}
		//ŃC[W쐬
		MemoryImageSource mis=new MemoryImageSource(imageWidthSmall,imageHeightSmall,pixsmall,0,imageWidthSmall);
		img=createImage(mis);
		//fBAgbJ[ŃC[W̊҂
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(img, 0);
		try{
			mt.waitForID(0);
		}catch(InterruptedException iee){}
		//C[W̃sNZzJɂ
		pix=null;
	}
	//--------------------------------------------------------
	//אڃs[Xoin߂͂̕Ŏgj
	//--------------------------------------------------------
	//nꂽp^[t@C̐Fo^
	public void addTouch(int d){
		//ɓo^ĂȂ
		for(int i=touchpix.size()-1;i>=0;i--){
			if( (touchpix.get(i)).intValue()==d){
				return;	//o^ĂΉI
			}
		}
		//o^ĂȂ΁A̐Fo^
		touchpix.add(new Integer(d));
	}
	//nꂽs[XƐڂĂ΂݂Ƀs[Xԍo^
	public void checkTouch(int i,MPJPiece p,int j){
		//̐F񂪓o^Ă邩oɒׂ
		if(checkTouchpix(p.pattern) || p.checkTouchpix(pattern)){
			//o^Ă
			addTouchNum(j);		//ɑ̃s[Xԍo^
			p.addTouchNum(i);	//Ɏ̃s[Xԍo^
			return;
		}
	}
	//nꂽF񂪓o^Ă邩
	public boolean checkTouchpix(int p){
		//Ԃɒׂ
		for(int i=0;i<touchpix.size();i++){
			if((touchpix.get(i)).intValue()==p){
				return true;	//o^Ă
			}
		}
		//o^ĂȂ
		return false;
	}
	//nꂽs[Xԍo^
	public void addTouchNum(int n){
		touchnum.add(new Integer(n));
	}
	//s[XԍArrayListzɈڂi͂̍Ōɍsj
	public void makeTouch(){
		//z쐬
		touch=new int[touchnum.size()];
		//ԂɈڂ
		for(int i=0;i<touchnum.size();i++){
			touch[i]=(touchnum.get(i)).intValue();
		}
		//ArrayListJɂ
		touchpix=null;
		touchnum=null;
	}
	//--------------------------------------------------------
	//O[v
	//--------------------------------------------------------
	//nꂽs[XƓO[vɓ邩iʒuIɁj
	public boolean checkGroupable(MPJPiece p){
		//ʒu\߂ǂ
		if(Math.abs(p.px-px)<10 && Math.abs(p.py-py)<10){
			return true;	//߂
		}else{
			return false;	//
		}
	}
	//nꂽs[XƓO[vɓ
	public void setGroup(MPJPiece p){
		//\ʒu𓯂ɂ
		px=p.px;
		py=p.py;
	}
	//--------------------------------------------------------
	//Ĩ`FbN
	//--------------------------------------------------------
	//}EX_Ëʒui΍Wj󂯎Ēׂ
	public boolean checkOn(int ax,int ay){
		//摜̑΍Wɕϊ
		int x=ax-(px+left);
		int y=ay-(py+up);
		//摜̏ォǂ
		if(x>=0 && x<imageWidthSmall && y>=0 && y<imageHeightSmall){
			return checkAlpha(pixsmall[y*imageWidthSmall+x]);	//摜̏łiǂ`FbNj
		}else{
			return false;									//摜̏ザȂiIłȂj
		}
	}
	//摜̎w肳ꂽsNZǂ
	private boolean checkAlpha(int d){
		int a=(d >> 24) & 0xff;	//At@[lixjo
		if(a>0){
			return true;	//񓧖iIłj
		}else{
			return false;	//iIłȂj
		}
	}
	//--------------------------------------------------
	//s[Ẍʒu
	//--------------------------------------------------
	//w肳ꂽ傫ړ
	public void moveImage(int x,int y){
		px+=x;
		py+=y;
	}
	//w肳ꂽʒuɈړi[hŎgj
	public void moveImageTo(int x,int y){
		px=x;
		py=y;
	}
	//}\̈ʒu
	public void formatPos(int medx,int medy){
		px=medx;
		py=medy;
	}
	//_ȈʒuɈړ
	public void randomPos(int f_width,int f_height){
		//Oɂ͂ݏoȂ悤
		px=(int)(-left+(f_width-(right-left))*Math.random());
		py=(int)(-up+(f_height-(down-up))*Math.random());
	}
	//\ʒûwW
	public int getPX(){
		return px+left;
	}
	//\ʒûxW
	public int getPY(){
		return py+up;
	}
	//--------------------------------------------------
	//O[v摜̍ŊOWǉ
	//--------------------------------------------------
	public Point addImageAreaLeftUp(Point p){
		int l,u;
		if(p!=null){
			l=(p.x<px+left)?p.x:px+left;
			u=(p.y<py+up)?p.y:py+up;
		}else{
			l=px+left;
			u=py+up;
		}
		//
		return new Point(l,u);
	}
	public Point addImageAreaRightDown(Point p){
		int r,d;
		if(p!=null){
			r=(p.x>px+right)?p.x:px+right;
			d=(p.y>py+down)?p.y:py+down;
		}else{
			r=px+right;
			d=py+down;
		}
		//
		return new Point(r,d);
	}
	//--------------------------------------------------
	//Z[uiMPJFieldĂяoj
	//--------------------------------------------------
	public String getSaveString(){	//Z[upf[^Ԃ
		StringBuffer ret=new StringBuffer();
		ret.append(px+",");
		ret.append(py+"\n");
		//
		return ret.toString();
	}
}
