import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class MPJNewJigsawDialog extends JDialog implements ActionListener {
	//
	MPJApp parent;	//Ăяõt[
	//摜\g
	MPJHintPanel patternImagePanel=new MPJHintPanel();
	MPJHintPanel baseImagePanel=new MPJHintPanel();
	//
	JButton buttonPattern=new JButton("I(P)");
	JTextField fieldPatternWidth=new JTextField("",3);
	JTextField fieldPatternHeight=new JTextField("",3);
	JTextField fieldPatternName=new JTextField("",14);
	//
	JButton buttonBase=new JButton("I(B)");
	JTextField fieldBaseWidth=new JTextField("",3);
	JTextField fieldBaseHeight=new JTextField("",3);
	JTextField fieldBaseName=new JTextField("",14);
	//
	JButton buttonBack=new JButton("wi摜(I)");
	JTextField fieldBackName=new JTextField("",8);
	//
	JButton buttonColor=new JButton("wiF(L)");
	JTextField fieldColor=new JTextField("",2);
	//
	JButton buttonBackFormat=new JButton("wi(F)");
	//
	JButton buttonOk=new JButton("OK");
	JButton buttonCancel=new JButton("CANCEL");
	//ĂԁAꎞIɃf[^Ă
	File[] files;
	Image[] images;
	//-------------------------------------------------------------
	//RXgN^
	//-------------------------------------------------------------
	public MPJNewJigsawDialog(Frame owner){
		super(owner,"VpY쐬",true);
		parent=(MPJApp)owner;
		//
		patternImagePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder()));	//g
		patternImagePanel.setPreferredSize(new Dimension(200,200));
		baseImagePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder()));	//g
		baseImagePanel.setPreferredSize(new Dimension(200,200));
		//
		fieldPatternWidth.setEditable(false);
		fieldPatternHeight.setEditable(false);
		fieldPatternName.setEditable(false);
		fieldBaseWidth.setEditable(false);
		fieldBaseHeight.setEditable(false);
		fieldBaseName.setEditable(false);
		fieldBackName.setEditable(false);
		fieldColor.setEditable(false);
		fieldColor.setBackground(MPJField.DEFAULT_BACK_COLOR);
		buttonOk.setEnabled(false);
		//j[jbNiL[{[hAlt+?őIj
		buttonPattern.setMnemonic(KeyEvent.VK_P);
		buttonBase.setMnemonic(KeyEvent.VK_B);
		buttonBack.setMnemonic(KeyEvent.VK_I);
		buttonColor.setMnemonic(KeyEvent.VK_L);
		buttonBackFormat.setMnemonic(KeyEvent.VK_F);
		//
		JPanel patternSubPanel=new JPanel();
		patternSubPanel.add(buttonPattern);
		patternSubPanel.add(new JLabel(":"));
		patternSubPanel.add(fieldPatternWidth);
		patternSubPanel.add(new JLabel("wc:"));
		patternSubPanel.add(fieldPatternHeight);
		JPanel patternPanel=new JPanel();
		patternPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"p^["));	//g
		patternPanel.setLayout(new BorderLayout());
		patternPanel.add(patternSubPanel,BorderLayout.NORTH);
		patternPanel.add(patternImagePanel,BorderLayout.CENTER);
		patternPanel.add(fieldPatternName,BorderLayout.SOUTH);
		//
		JPanel baseSubPanel=new JPanel();
		baseSubPanel.add(buttonBase);
		baseSubPanel.add(new JLabel(":"));
		baseSubPanel.add(fieldBaseWidth);
		baseSubPanel.add(new JLabel("wc:"));
		baseSubPanel.add(fieldBaseHeight);
		JPanel basePanel=new JPanel();
		basePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"pY摜"));	//g
		basePanel.setLayout(new BorderLayout());
		basePanel.add(baseSubPanel,BorderLayout.NORTH);
		basePanel.add(baseImagePanel,BorderLayout.CENTER);
		basePanel.add(fieldBaseName,BorderLayout.SOUTH);
		//
		JPanel otherPanel=new JPanel();
		otherPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"wi"));	//g
		otherPanel.add(buttonBack);
		otherPanel.add(fieldBackName);
		otherPanel.add(buttonColor);
		otherPanel.add(fieldColor);
		otherPanel.add(buttonBackFormat);
		JPanel buttonPanel=new JPanel();
		buttonPanel.add(buttonOk);
		buttonPanel.add(buttonCancel);
		//
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.fill=GridBagConstraints.BOTH;
		GridBagLayout gbl=new GridBagLayout();
		JPanel settingPanel=new JPanel();
		settingPanel.setLayout(gbl);
		//gbc.gridwidth=1;
		//gbc.gridheight=1;
		gbl.setConstraints(patternPanel,gbc);
		settingPanel.add(patternPanel);		//
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		//gbc.gridheight=1;
		gbl.setConstraints(basePanel,gbc);
		settingPanel.add(basePanel);		//
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbl.setConstraints(otherPanel,gbc);
		settingPanel.add(otherPanel);		//
		//Reig
		Container cp=getContentPane();
		cp.add(settingPanel,BorderLayout.CENTER);
		cp.add(buttonPanel,BorderLayout.SOUTH);
		//
		//TCY
		pack();
		//ʂ̐^񒆂ɕ\iTCY̌j
		setLocationRelativeTo(null);
		//
		buttonPattern.addActionListener(this);
		buttonBase.addActionListener(this);
		buttonBack.addActionListener(this);
		buttonColor.addActionListener(this);
		buttonBackFormat.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
	}
	//-------------------------------------------------------------
	//OɃf[^𔽉f
	//-------------------------------------------------------------
	public void fitStateToData(){
		//f[^󂯎
		files=new File[MPJData.I_ALL];
		images=new Image[MPJData.I_ALL];
		for(int i=0;i<MPJData.I_ALL;i++){
			files[i]=parent.dataStore.files[i];
			images[i]=parent.dataStore.images[i];
		}
		//Rg[ɔf
		if(!files[MPJData.I_PATTERN].isDirectory()){
			fieldPatternName.setText(files[MPJData.I_PATTERN].getName());
			fieldPatternWidth.setText(String.valueOf(images[MPJData.I_PATTERN].getWidth(this)));
			fieldPatternHeight.setText(String.valueOf(images[MPJData.I_PATTERN].getHeight(this)));
			//摜\
			patternImagePanel.setImage(images[MPJData.I_PATTERN]);
		}else{
			fieldPatternName.setText("");
			fieldPatternWidth.setText("");
			fieldPatternHeight.setText("");
			//摜
			patternImagePanel.setImage(null);
		}
		if(!files[MPJData.I_BASE].isDirectory()){
			fieldBaseName.setText(files[MPJData.I_BASE].getName());
			fieldBaseWidth.setText(String.valueOf(images[MPJData.I_BASE].getWidth(this)));
			fieldBaseHeight.setText(String.valueOf(images[MPJData.I_BASE].getHeight(this)));
			//摜\
			baseImagePanel.setImage(images[MPJData.I_BASE]);
		}else{
			fieldBaseName.setText("");
			fieldBaseWidth.setText("");
			fieldBaseHeight.setText("");
			//摜
			baseImagePanel.setImage(null);
		}
		if(!files[MPJData.I_BACK].isDirectory()){
			fieldBackName.setText(files[MPJData.I_BACK].getName());
		}else{
			fieldBackName.setText("");
		}
		fieldColor.setBackground(parent.dataStore.backColor);
		//OK{^̗L
		enableOkButton();
	}
	//-------------------------------------------------------------
	//{^Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPattern){
			if(getImageOnNewJigsaw("p^[t@CI",MPJData.I_PATTERN)){
				fieldPatternName.setText(files[MPJData.I_PATTERN].getName());
				fieldPatternWidth.setText(String.valueOf(images[MPJData.I_PATTERN].getWidth(this)));
				fieldPatternHeight.setText(String.valueOf(images[MPJData.I_PATTERN].getHeight(this)));
				enableOkButton();
				//I摜\
				patternImagePanel.setImage(images[MPJData.I_PATTERN]);
				repaint();
			}
		}else if(object==buttonBase){
			if(getImageOnNewJigsaw("pY摜I",MPJData.I_BASE)){
				fieldBaseName.setText(files[MPJData.I_BASE].getName());
				fieldBaseWidth.setText(String.valueOf(images[MPJData.I_BASE].getWidth(this)));
				fieldBaseHeight.setText(String.valueOf(images[MPJData.I_BASE].getHeight(this)));
				enableOkButton();
				//I摜\
				baseImagePanel.setImage(images[MPJData.I_BASE]);
				repaint();
			}
		}else if(object==buttonBack){
			if(getImageOnNewJigsaw("wi摜I",MPJData.I_BACK)){
				fieldBackName.setText(files[MPJData.I_BACK].getName());
			}
		}else if(object==buttonColor){
			Color tmpColor=JColorChooser.showDialog(this,"wiFI",fieldColor.getBackground());
			if(tmpColor!=null){
				fieldColor.setBackground(tmpColor);
			}
		}else if(object==buttonBackFormat){
			//
			files[MPJData.I_BACK]=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+MPJData.N_DIR[MPJData.I_BACK]+".");
			images[MPJData.I_BACK]=null;
			fieldBackName.setText("");
			//
			fieldColor.setBackground(MPJField.DEFAULT_BACK_COLOR);
		}else if(object==buttonOk){
			setVisible(false);
			//VK쐬Ȃ̂ŖZ[uɂ
			parent.dataStore.formatSaveFileData(true);	//EditorƂă^CgύX(Playerł͂Ȃ͂)
			//f[^ڂA[Jf[^͏
			parent.dataStore.setPuzzleData(files,images,fieldColor.getBackground());
			files=null;	//܂\OfitStateToData()ō
			images=null;
			//VpY쐬
			parent.makeNewJigsaw();
		}else if(object==buttonCancel){
			setVisible(false);
			//[Jf[^
			files=null;	//܂\OfitStateToData()ō
			images=null;
		}
	}
	//--------------------------------------------------------
	//_CAO\ĉ摜擾i擾trueԂj
	//--------------------------------------------------------
	private boolean getImageOnNewJigsaw(String title,int type){
		File tmpFile;
		Image tmpImage;
		//摜t@CI
		tmpFile=MPJData.getTargetFile(parent, title, "I", files[type], null,false);
		//IȂ
		if(tmpFile!=null){
			tmpImage=Toolkit.getDefaultToolkit().getImage(tmpFile.getPath());
			MediaTracker mt=new MediaTracker(this);
			mt.addImage(tmpImage,0);
			//fBAgbJ[œǂݍݏI܂ő҂
			try{
				mt.waitForAll();
			}catch(InterruptedException e){
				return false;
			}
			//w肳ꂽ摜ނɃf[^i[
			files[type]=tmpFile;
			images[type]=tmpImage;
			//
			return true;
		}else{
			return false;
		}
	}
	//-------------------------------------------------------------
	//OK{^̗L
	//-------------------------------------------------------------
	private void enableOkButton(){
		if(!files[MPJData.I_PATTERN].isDirectory() && !files[MPJData.I_BASE].isDirectory() &&
		images[MPJData.I_PATTERN].getWidth(this)==images[MPJData.I_BASE].getWidth(this) &&
		images[MPJData.I_PATTERN].getHeight(this)==images[MPJData.I_BASE].getHeight(this)){
			buttonOk.setEnabled(true);
		}else{
			buttonOk.setEnabled(false);
		}
	}
}
