import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.jar.Attributes;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;
import java.util.jar.Manifest;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

public class MPJOutPlayerDialog extends JDialog implements ActionListener {
	//----------萔------------
	//t@C̍ږw
	static final String NO_STR="no";
	//Playerɕۑt@C
	static final String CREDIT_FILE="info.txt";
	//PlayerɃRs[NX
	static final String[] CLASS_COPY=new String[]{
			"MPJApp.class","MPJField.class","MPJData.class","MPJPiece.class",
			"MPJNewJigsawDialog.class","MPJOutPlayerDialog.class",
			"MPJHintDialog.class","MPJHintPanel.class",
			"MPJInfoDialog.class","MPJInfoPanel.class",
			};
	//
	//----------ϐ------------
	//
	MPJApp frame;
	//
	JFileChooser chooser;
	//
	JTextField fieldPath=new JTextField(15);
	JButton buttonPath=new JButton("st@C");
	//
	JTextField fieldTitle=new JTextField(18);
	MPJInfoPanel infoPanel=new MPJInfoPanel(true);	//ҏW\
	//
	JRadioButton radioHintOn=new JRadioButton("on",true);
	JRadioButton radioHintOff=new JRadioButton("off");
	JRadioButton radioAnswerOn=new JRadioButton("on",true);
	JRadioButton radioAnswerOff=new JRadioButton("off");
	//
	JButton buttonOk=new JButton("o");
	JButton buttonCancel=new JButton("");
	//o͐
	File targetFile;
	//Playeȑt@C̃f[^iNɎ擾ĂKXQƂj
	//	摜֌W
	String infoFileBase;	//0.摜̃t@C
	String infoFilePattern;	//1.p^[̃t@C
	String infoFileBack;	//2.wi摜̃t@C
	Color infoBackColor;	//3.wiF
	//	ʉ
	String infoSEBang;		//4.̉̃t@C
	String infoSETouch;		//5.ڑ̉̃t@C
	String infoSEFinish;	//6.̉̃t@C
	//	IvV
	boolean infoOptHint;	//7.qg\
	boolean infoOptAnswer;	//8.𓚕\
	//	҂ɂw
	String infoFile;		//9.g̃t@Cigqj
	String infoTitle;		//10.^Cg
	//11.ҁiinfoDialogŏj
	//12ȉ.RgiinfoDialogŏj
	//
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public MPJOutPlayerDialog(MPJApp frm){
		super(frm,"st@Cɏo",true);
		frame=frm;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//ڂ͕ҏWłȂ
		fieldPath.setEditable(false);
		//
		//
		JPanel panelExe=new JPanel();	//1-1
		panelExe.add(fieldPath);
		panelExe.add(buttonPath);
		//
		ButtonGroup radioGroupHint=new ButtonGroup();
		radioGroupHint.add(radioHintOn);
		radioGroupHint.add(radioHintOff);
		ButtonGroup radioGroupAnswer=new ButtonGroup();
		radioGroupAnswer.add(radioAnswerOn);
		radioGroupAnswer.add(radioAnswerOff);
		//
		JPanel hintPanel=new JPanel();		//1-2-1
		hintPanel.add(new Label("qg\F"));
		hintPanel.add(radioHintOn);
		hintPanel.add(radioHintOff);
		JPanel answerPanel=new JPanel();	//1-2-2
		answerPanel.add(new Label("𓚕\F"));
		answerPanel.add(radioAnswerOn);
		answerPanel.add(radioAnswerOff);
		JPanel optionPanel=new JPanel();	//1-2
		optionPanel.setLayout(new GridLayout(2,1));
		optionPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"IvV"));	//g
		optionPanel.add(hintPanel);
		optionPanel.add(answerPanel);
		//
		JPanel functionPanel=new JPanel();	//1
		functionPanel.setLayout(new BorderLayout());
		functionPanel.add(panelExe,BorderLayout.NORTH);
		functionPanel.add(optionPanel,BorderLayout.CENTER);
		//
		JPanel panelTitle=new JPanel();	//2-1
		panelTitle.add(new JLabel("^CgF"));
		panelTitle.add(fieldTitle);
		//
		JPanel panelInfo=new JPanel();	//2
		panelInfo.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),""));	//g
		panelInfo.setLayout(new BorderLayout());
		panelInfo.add(panelTitle,BorderLayout.NORTH);
		panelInfo.add(infoPanel,BorderLayout.CENTER);
		//
		JPanel panelButton=new JPanel();	//3
		panelButton.add(buttonOk);
		panelButton.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(functionPanel,BorderLayout.NORTH);
		cp.add(panelInfo,BorderLayout.CENTER);
		cp.add(panelButton,BorderLayout.SOUTH);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		buttonPath.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//o͐
		targetFile=null;
	}
	//******************************************************************************************************
	//{^̑Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPath){				//jarw
			getTargetJar();
		}else if(object==buttonOk){
			if(checkDataConform()){
				setVisible(false);
				//Playero
				outputPlayer();
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	//o͐擾
	//------------------------------------------------------------------------------------------------------
	private void getTargetJar(){
		chooser.setSelectedFile(targetFile);
		chooser.setDialogTitle("st@C(*.jar)o͐I");
		int ret=chooser.showDialog(this, "I");
		if(ret==JFileChooser.APPROVE_OPTION){
			targetFile=chooser.getSelectedFile();
			//gqtĂȂΕt
			targetFile=MPJApp.addExtension(targetFile, "jar");
			//
			fieldPath.setText(targetFile.getPath());
		}
	}
	//******************************************************************************************************
	//	t@C
	//------------------------------------------------------------------------------------------------------
	private String getInfoString() {
		StringBuffer out=new StringBuffer();
		//0.摜
		addStr(out,frame.dataStore.files[MPJData.I_BASE].getName());
		//1.p^[
		addStr(out,frame.dataStore.files[MPJData.I_PATTERN].getName());
		//2.wi摜
		if(frame.dataStore.images[MPJData.I_BACK]!=null) {
			addStr(out,frame.dataStore.files[MPJData.I_BACK].getName());
		}else {
			addStr(out,NO_STR);
		}
		//3.wiF
		addStr(out,MPJData.getStringFromColor(frame.dataStore.backColor));
		//	ʉ
		addStr(out,getSEName("bang"));		//4
		addStr(out,getSEName("touch"));		//5
		addStr(out,getSEName("finish"));	//6
		//7.qg\
		if(radioHintOn.isSelected()){
			addStr(out,"yes");
		}else{
			addStr(out,NO_STR);
		}
		//8.𓚕\
		if(radioAnswerOn.isSelected()){
			addStr(out,"yes");
		}else{
			addStr(out,NO_STR);
		}
		//
		//9.t@Cigqj
		String tmpStr=targetFile.getName();
		out.append( tmpStr.substring(0,tmpStr.indexOf(".")) ).append( System.getProperty("line.separator") );
		//10.^Cg
		addStr(out,fieldTitle.getText());
		//11.
		addStr(out,infoPanel.getAuther());
		//12.Rgis͂̂܂܁j
		addStr(out,infoPanel.getComment());
		//
		return out.toString();
	}
	private String getSEName(String seType) {
		//jarOɁu*.wavvΕʏiu*.auvȂjarƓȂ̂œ)
		File file=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+"se"+System.getProperty("file.separator")+seType+".wav");
		if(file.exists()){
			return seType+".wav";
		}else {
			return seType+".au";
		}
	}
	static private void addStr(StringBuffer strBuf,String adStr){
		final String br=System.getProperty("line.separator");
		//
		if(adStr.length()==0){
			strBuf.append(NO_STR).append(br);
		}else{
			strBuf.append(adStr).append(br);
		}
	}
	//******************************************************************************************************
	//̓f[^̐`FbN
	//------------------------------------------------------------------------------------------------------
	private boolean checkDataConform(){
		if(targetFile==null){
			frame.showErrorDialog("o͐w肵ĂB");
			return false;
		}
		//
		return true;
	}
	//******************************************************************************************************
	//	Playt@Co
	//------------------------------------------------------------------------------------------------------
	//JARŁAN\ȃAvP[Vo͂
	private void outputPlayer(){
		try {
			//}jtFXg쐬
			Manifest manifest=new Manifest();
			Attributes attributes=manifest.getMainAttributes();
			attributes.put(Attributes.Name.MANIFEST_VERSION, "1.0");
			attributes.put(Attributes.Name.MAIN_CLASS, "MPJField");	//Play̏ꍇPanelmain
			//̃}jtFXgJAR쐬
			JarOutputStream jos=new JarOutputStream(new BufferedOutputStream(new FileOutputStream(targetFile)),manifest);
			//
			//	NX
			copyPlayer(jos,CLASS_COPY);										//NXJARɃRs[
			//	
			makeTextFile(getInfoString(),jos,CREDIT_FILE);					//t@CJARɍ쐬
			//	摜JARɃRs[
			File[] tmpFiles=frame.dataStore.files;
			Image[] tmpImages=frame.dataStore.images;
			//	摜
			copyImage(tmpImages[MPJData.I_BASE],jos,tmpFiles[MPJData.I_BASE].getName());
			//	p^[
			copyImage(tmpImages[MPJData.I_PATTERN],jos,tmpFiles[MPJData.I_PATTERN].getName());
			//	wi
			if(tmpImages[MPJData.I_BACK]!=null) {
				copyImage(tmpImages[MPJData.I_BACK],jos,tmpFiles[MPJData.I_BACK].getName());
			}
			//	ʉ
			copySE(jos,"bang");
			copySE(jos,"touch");
			copySE(jos,"finish");
			//
			jos.close();
			//
			frame.showInfoDialog("o͂܂", "");
		} catch (IOException ioe) {
			frame.showErrorDialog("o͒ɃG[\n"+ioe.toString());
		}

	}
	static private void copyPlayer(JarOutputStream jos,String[] targetClass) throws IOException{
		//t@Cog
		JarFile jarSelf=new JarFile(System.getProperty("user.dir")+System.getProperty("file.separator")+"MPJApp.jar");
		//
		for(int c=0;c<targetClass.length;c++) {
			JarEntry playerEntryFrom=new JarEntry(targetClass[c]);
			//
			BufferedInputStream bis=new BufferedInputStream(jarSelf.getInputStream(playerEntryFrom));
			//
			JarEntry playerEntryTo=new JarEntry(targetClass[c]);
			jos.putNextEntry(playerEntryTo);
			//
			int b;
			while((b=bis.read())!=-1){
				jos.write((byte)b);
			}
			//
			jos.closeEntry();
			bis.close();
		}
		//
		jarSelf.close();
	}
	static private void makeTextFile(String info,JarOutputStream jos,String targetName) throws IOException{
		//w̃t@CŃGg[ǉ
		JarEntry settingEntry=new JarEntry(targetName);	//
		jos.putNextEntry(settingEntry);
		//w̕
		jos.write(info.getBytes());
		//
		jos.closeEntry();
	}
	private void copyImage(Image img,JarOutputStream jos,String targetName) throws IOException{
		//摜t@C̎ށigqj
		String imageType;
		int period=targetName.lastIndexOf(".");
		if(period!=-1 && period<targetName.length()-1) {	//gq
			imageType=targetName.substring(period+1);
		}else {
			imageType="jpg";	//s̏ꍇ
		}
		//
		//ۑp摜
		BufferedImage bufImage;
		if(imageType.equals("gif")){	//GIFɑΉ邽 TYPE_INT_ARGB ɂ
			bufImage=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_ARGB);
		}else{							//
			bufImage=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_RGB);
		}
		Graphics g=bufImage.getGraphics();
		//g.setColor(Color.WHITE);
		//g.fillRect(0,0,bufImage.getWidth(),bufImage.getHeight());
		g.drawImage(img, 0, 0, this);
		//摜f[^o
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ImageIO.write(bufImage, imageType, baos);
		baos.flush();
		byte[] imageInByte = baos.toByteArray();
		baos.close();
		//
		InputStream is = new ByteArrayInputStream(imageInByte);		//
		BufferedInputStream bis=new BufferedInputStream(is);
		//w̃t@CŃGg[ǉ
		JarEntry outEntry=new JarEntry(targetName);	//
		jos.putNextEntry(outEntry);
		//摜f[^o
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
	}
	private void copySE(JarOutputStream jos,String seType/*gqt@C*/) throws IOException {
		//jarOɁu*.wavv́u*.auv邩
		File file=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+"se"+System.getProperty("file.separator")+seType+".wav");
		if(file.exists()){
			copyOutSE(file,jos);			//Ou*.wavv
		}else{
			file=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+"se"+System.getProperty("file.separator")+seType+".au");
			if(file.exists()){
				copyOutSE(file,jos);		//Ou*.auv
			}else{
				//jarOɂȂΓ̂g
				copyInSE(seType+".au",jos);	//u*.auv
			}
		}
	}
	private void copyOutSE(File targetSEFile,JarOutputStream jos) throws IOException{
		BufferedInputStream bis=new BufferedInputStream(new FileInputStream(targetSEFile));
		//Gg[ǉ
		JarEntry outEntry=new JarEntry(targetSEFile.getName());	//
		jos.putNextEntry(outEntry);
		//
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
	}
	private void copyInSE(String targetSEName/*gq܂񂾃t@C*/,JarOutputStream jos) throws IOException{
		//t@Cog
		JarFile jarSelf=new JarFile(System.getProperty("user.dir")+System.getProperty("file.separator")+"MPJApp.jar");
		JarEntry playerEntryFrom=new JarEntry(targetSEName);
		//
		BufferedInputStream bis=new BufferedInputStream(jarSelf.getInputStream(playerEntryFrom));
		//
		JarEntry playerEntryTo=new JarEntry(targetSEName);
		jos.putNextEntry(playerEntryTo);
		//
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
		//
		jarSelf.close();
	}
	//******************************************************************************************************
	//	Playt@Cǂݍ
	//------------------------------------------------------------------------------------------------------
	//t@C
	public boolean getInfoFromPlayer(MPJInfoDialog infoDlg){
		//ǂݍ
		String[] infoStr=readTextFromPlayer(CREDIT_FILE);
		if(infoStr==null){
			frame.showErrorDialog("Playeȑt@C݂܂");
			return false;	//ǂݍ݃G[
		}
		if(infoStr.length<13){
			frame.showErrorDialog("Playeȑt@CԈĂ܂");
			return false;	//ss
		}
		//f[^ȅ
		//	摜
		infoFileBase=infoStr[0];	//0.摜
		infoFilePattern=infoStr[1];	//1.p^[
		infoFileBack=infoStr[2];	//2.wi摜
		//	3.wiF
		infoBackColor=MPJData.getColorFromString(infoStr[3]);
		//	ʉ
		infoSEBang=infoStr[4];		//4.
		infoSETouch=infoStr[5];		//5.
		infoSEFinish=infoStr[6];	//6.
		//	7.qg\
		if(infoStr[7].equals(NO_STR)){
			infoOptHint=false;
		}else{
			infoOptHint=true;
		}
		//	8.𓚕\
		if(infoStr[8].equals(NO_STR)){
			infoOptAnswer=false;
		}else{
			infoOptAnswer=true;
		}
		//	9.t@Cigqj
		infoFile=infoStr[9];
		//	10.^Cg
		if(infoStr[10].equals(NO_STR)){
			infoTitle=infoStr[9];	//wȂt@CK
		}else{
			infoTitle=infoStr[10];
		}
		//	11.	12ȍ~.RgiinfoDialogɓn\j
		StringBuffer com=new StringBuffer();
		for(int c=12;c<infoStr.length;c++){
			com.append(infoStr[c]).append("\n");
		}
		infoDlg.setInfoData(infoStr[11], /*Ō̉s͏*/com.substring(0,com.length()-1));
		//
		//I
		return true;
	}
	//JAR̃eLXgt@Cǂݍ݁iėpj
	private String[] readTextFromPlayer(String target){			//
		try{
			//ݒt@Cǂݍ
			String ret[];
			//jar̃eLXgt@C̓̓Xg[𓾂
			InputStream is=getClass().getResourceAsStream(target);	//̃NX璼ړǂݍ
			//StreamiÂnjReaderiVnj֕ϊ
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			//
			ArrayList<String> array=new ArrayList<String>();
			String str;
			while( (str=br.readLine())!=null ){
				array.add(str);
			}
			//
			br.close();
			//
			ret=new String[array.size()];
			for(int i=0;i<ret.length;i++){
				ret[i]=array.get(i);
			}
			//
			return ret;
		}catch(IOException e){
			frame.showErrorDialog("PlayereLXgt@C̓ǂݍ݂ŃG[\n"+e.toString());
			return null;
		}
	}
}
